#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six16004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six16004xi = {
                1:'-1009x1241y-4z',
                2:'-1015x1088y-586z',
                3:'-1046x1035y-627z',
                4:'-1067x1029y-601z',
                5:'-1073x1186y-20z',
                6:'-1094x974y-641z',
                7:'-110x610y-1474z',
                8:'-1114x968y-616z',
                9:'-1133x1128y-36z',
                10:'-1138x912y-656z',
                11:'-1159x904y-631z',
                12:'-1179x847y-671z',
                13:'-1190x1067y-52z',
                14:'-1199x838y-645z',
                15:'-1216x781y-685z',
                16:'-1236x771y-660z',
                17:'-1244x1003y-68z',
                18:'-1249x712y-699z',
                19:'-1269x702y-675z',
                20:'-1279x643y-714z',
                21:'-1294x936y-84z',
                22:'-1304x572y-728z',
                23:'-1325x500y-742z',
                24:'-1341x866y-100z',
                25:'-1342x428y-756z',
                26:'-1356x355y-771z',
                27:'-1365x282y-784z',
                28:'-1368x64y-826z',
                29:'-1370x209y-798z',
                30:'-1371x136y-812z',
                31:'-1379x671y-732z',
                32:'-1383x794y-116z',
                33:'-138x589y-1481z',
                34:'-141x1136y-1117z',
                35:'-1422x720y-132z',
                36:'-1456x644y-148z',
                37:'-1487x567y-164z',
                38:'-1513x487y-180z',
                39:'-1534x407y-196z',
                40:'-1551x326y-212z',
                41:'-1564x244y-227z',
                42:'-1573x161y-243z',
                43:'-1576x79y-259z',
                44:'-165x566y-1487z',
                45:'-169x1531y-431z',
                46:'-189x543y-1492z',
                47:'-198x1116y-1128z',
                48:'-212x518y-1498z',
                49:'-219x6y-1584z',
                50:'-232x493y-1504z',
                51:'-235x19y-1582z',
                52:'-248x1516y-446z',
                53:'-249x34y-1580z',
                54:'-250x467y-1509z',
                55:'-254x1093y-1139z',
                56:'-262x49y-1577z',
                57:'-267x440y-1514z',
                58:'-268x1520y-419z',
                59:'-275x67y-1574z',
                60:'-281x413y-1519z',
                61:'-286x86y-1571z',
                62:'-293x386y-1524z',
                63:'-296x106y-1568z',
                64:'-303x358y-1529z',
                65:'-304x127y-1565z',
                66:'-307x1067y-1150z',
                67:'-311x150y-1562z',
                68:'-311x331y-1534z',
                69:'-317x174y-1558z',
                70:'-317x303y-1538z',
                71:'-320x198y-1554z',
                72:'-320x276y-1542z',
                73:'-322x223y-1551z',
                74:'-322x250y-1547z',
                75:'-326x1496y-461z',
                76:'-347x1500y-435z',
                77:'-359x1039y-1162z',
                78:'-402x1473y-477z',
                79:'-409x1008y-1172z',
                80:'-423x1475y-450z',
                81:'-456x974y-1183z',
                82:'-478x1445y-492z',
                83:'-47x647y-1462z',
                84:'-499x1446y-466z',
                85:'-501x939y-1194z',
                86:'-543x901y-1205z',
                87:'-551x1413y-507z',
                88:'-572x1414y-481z',
                89:'-583x861y-1215z',
                90:'-620x820y-1225z',
                91:'-622x1378y-522z',
                92:'-643x1378y-496z',
                93:'-654x777y-1236z',
                94:'-685x732y-1246z',
                95:'-691x1339y-537z',
                96:'-712x1338y-511z',
                97:'-713x687y-1256z',
                98:'-739x640y-1266z',
                99:'-757x1296y-552z',
                100:'-761x593y-1275z',
                101:'-778x1294y-526z',
                102:'-781x545y-1285z',
                103:'-797x496y-1294z',
                104:'-79x629y-1468z',
                105:'-805x26y-1382z',
                106:'-811x448y-1304z',
                107:'-816x70y-1374z',
                108:'-821x1250y-567z',
                109:'-821x399y-1313z',
                110:'-825x114y-1365z',
                111:'-829x350y-1322z',
                112:'-831x160y-1357z',
                113:'-834x302y-1331z',
                114:'-835x206y-1348z',
                115:'-836x254y-1340z',
                116:'-842x1247y-541z',
                117:'-882x1200y-582z',
                118:'-903x1197y-556z',
                119:'-940x1148y-597z',
                120:'-961x1144y-571z',
                121:'-994x1093y-612z'}


#"
#/>



# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire1600six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1600SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1600SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1600SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1600SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1600SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six16004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1600SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1600SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1600SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six1600x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six1600x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1600SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE1600SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1600SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
